// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'wclSerialClients.pas' rev: 6.00

#ifndef wclSerialClientsHPP
#define wclSerialClientsHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <wclWinAPI.hpp>	// Pascal unit
#include <wclErrors.hpp>	// Pascal unit
#include <wclConnections.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Wclserialclients
{
//-- type declarations -------------------------------------------------------
#pragma option push -b
enum TwclSerialDtrControl { dtrControlDisable, dtrControlEnable, dtrControlHandshake };
#pragma option pop

#pragma option push -b
enum TwclSerialRtsControl { rtsControlDisable, rtsControlEnable, rtsControlHandshake, rtsControlToggle };
#pragma option pop

#pragma option push -b
enum TwclSerialParity { spNo, spOdd, spEven, spMark, spSpace };
#pragma option pop

typedef Set<TwclSerialParity, spNo, spSpace>  TwclSerialParities;

#pragma option push -b
enum TwclSerialStopBits { sbOne, sbOne5, sbTwo };
#pragma option pop

typedef Set<TwclSerialStopBits, sbOne, sbTwo>  TwclSerialStopBitsSet;

#pragma pack(push, 4)
struct TwclSerialConfig
{
	unsigned BaudRate;
	bool ParityCheck;
	bool OutxCtsFlow;
	bool OutxDsrFlow;
	TwclSerialDtrControl DtrControl;
	bool DsrSensitivity;
	bool TXContinueOnXoff;
	bool OutX;
	bool InX;
	bool ErrorCharReplace;
	bool NullStrip;
	TwclSerialRtsControl RtsControl;
	bool AbortOnError;
	Word XonLim;
	Word XoffLim;
	Byte ByteSize;
	TwclSerialParity Parity;
	TwclSerialStopBits StopBits;
	char XonChar;
	char XoffChar;
	char ErrorChar;
	char EofChar;
	char EvtChar;
} ;
#pragma pack(pop)

#pragma pack(push, 4)
struct TwclSerialTimeouts
{
	unsigned ReadInterval;
	unsigned ReadMultiplier;
	unsigned ReadConstant;
	unsigned WriteMultiplier;
	unsigned WriteConstant;
} ;
#pragma pack(pop)

#pragma option push -b
enum TwclSerialPurgeFlag { purgeRxAbort, purgeRxClear, purgeTxAbort, purgeTxClear };
#pragma option pop

typedef Set<TwclSerialPurgeFlag, purgeRxAbort, purgeTxClear>  TwclSerialPurgeFlags;

#pragma option push -b
enum TwclSerialEscapeFunction { escClrBreak, escClrDtr, escClrRts, escSetBreak, escSetDtr, escSetRts, escSetXoff, escSetXon };
#pragma option pop

#pragma option push -b
enum TwclSerialEvent { evBreak, evCts, evDsr, evRing, evRlsd, evChar };
#pragma option pop

typedef Set<TwclSerialEvent, evBreak, evChar>  TwclSerialEvents;

#pragma option push -b
enum TwclSerialError { erBreak, erFrame, erOverrun, erRxOver, erRxParity };
#pragma option pop

typedef Set<TwclSerialError, erBreak, erRxParity>  TwclSerialErrors;

#pragma option push -b
enum TwclSerialCommunicationState { csCtsHold, csDsrHold, csRlsdHold, csXoffHold, csXoffSent, csEof, csTxim };
#pragma option pop

typedef Set<TwclSerialCommunicationState, csCtsHold, csTxim>  TwclSerialCommunicationStates;

#pragma option push -b
enum TwclModemStatus { msCtsOn, msDsrOn, msRingOn, msRlsdOn };
#pragma option pop

typedef Set<TwclModemStatus, msCtsOn, msRlsdOn>  TwclModemStatuses;

#pragma option push -b
enum TwclSerialBaudRate { br075, br110, br134_5, br150, br300, br600, br1200, br1800, br2400, br4800, br7200, br9600, br14400, br19200, br38400, br56K, br57600, br115200, br128K, brUser };
#pragma option pop

typedef Set<TwclSerialBaudRate, br075, brUser>  TwclSerialBaudRates;

#pragma option push -b
enum TwclSerialType { stFax, stLat, stModem, stNetworkBridge, stParallelPort, stRS232, stRS422, stRS423, stRS449, stScanner, stTcpIpTelNet, stX25, stUnspecified };
#pragma option pop

#pragma option push -b
enum TwclSerialCapability { sc16BitMode, scDtrDsr, scIntervalTimeouts, scParityCheck, scRlsd, scRtsCts, scSetXChar, scSpecialChars, scTotalTimeouts, scXOnXoff };
#pragma option pop

typedef Set<TwclSerialCapability, sc16BitMode, scXOnXoff>  TwclSerialCapabilities;

#pragma option push -b
enum TwclSerialParam { spBaud, spDataBits, spHandshaking, spParity, spParityCheck, sRlsd, spStopBits };
#pragma option pop

typedef Set<TwclSerialParam, spBaud, spStopBits>  TwclSerialParams;

#pragma option push -b
enum TwclSerialDataSize { sdFive, sdSix, sdSeven, sdEight, sdSixteen, sdWide };
#pragma option pop

typedef Set<TwclSerialDataSize, sdFive, sdWide>  TwclSerialDataSizes;

#pragma pack(push, 4)
struct TwclSerialFeatures
{
	unsigned MaxTxBuffer;
	unsigned MaxRxBuffer;
	TwclSerialBaudRate MaxBaudRate;
	TwclSerialType SerialType;
	TwclSerialCapabilities Capabilities;
	TwclSerialParams SettableParams;
	TwclSerialBaudRates SettableBaud;
	TwclSerialDataSizes SettableData;
	TwclSerialStopBitsSet SettableStopBits;
	TwclSerialParities SettableParity;
} ;
#pragma pack(pop)

typedef void __fastcall (__closure *TwclSerialDeviceErrorEvent)(System::TObject* Sender, const TwclSerialErrors Errors, const TwclSerialCommunicationStates States);

typedef void __fastcall (__closure *TwclSerialDeviceEventsEvent)(System::TObject* Sender, const TwclSerialEvents Events);

typedef void __fastcall (__closure *TwclSerialDeviceReadErrorEvent)(System::TObject* Sender, const int Error);

class DELPHICLASS TwclSerialClient;
class PASCALIMPLEMENTATION TwclSerialClient : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	AnsiString FDeviceName;
	Wclconnections::TwclClientDataConnection* FConnection;
	Wclconnections::TwclClientConnectionConnectEvent FOnConnect;
	Wclconnections::TwclClientConnectionProcessorEvent FOnCreateProcessor;
	Wclconnections::TwclConnectionDataEvent FOnData;
	Wclconnections::TwclClientConnectionProcessorEvent FOnDestroyProcessor;
	Wclconnections::TwclClientConnectionDisconnectEvent FOnDisconnect;
	TwclSerialDeviceErrorEvent FOnError;
	TwclSerialDeviceEventsEvent FOnEvents;
	TwclSerialDeviceReadErrorEvent FOnReadError;
	Wclconnections::TwclCustomClientDataProcessor* __fastcall GetProcessor(void);
	Wclconnections::TwclClientState __fastcall GetState(void);
	unsigned __fastcall GetWriteTimeout(void);
	void __fastcall SetDeviceName(const AnsiString Value);
	void __fastcall SetWriteTimeout(const unsigned Value);
	void __fastcall ClientConnect(System::TObject* Sender, const int Error);
	void __fastcall ClientData(System::TObject* Sender, const void * Data, const unsigned Size);
	void __fastcall ClientDisconnect(System::TObject* Sender, const int Reason);
	void __fastcall ClientError(System::TObject* Sender, const TwclSerialErrors Errors, const TwclSerialCommunicationStates States);
	void __fastcall ClientEvents(System::TObject* Sender, const TwclSerialEvents Events);
	void __fastcall ClientReadError(System::TObject* Sender, const int Error);
	
protected:
	virtual void __fastcall DoConnect(const int Error);
	virtual void __fastcall DoCreateProcessor(const Wclconnections::TwclClientDataConnection* Connection);
	virtual void __fastcall DoData(const void * Data, const unsigned Size);
	virtual void __fastcall DoDestroyProcessor(const Wclconnections::TwclClientDataConnection* Connection);
	virtual void __fastcall DoDisconnect(const int Reason);
	virtual void __fastcall DoError(const TwclSerialErrors Errors, const TwclSerialCommunicationStates States);
	virtual void __fastcall DoEvents(const TwclSerialEvents Events);
	virtual void __fastcall DoReadError(const int Error);
	
public:
	__fastcall virtual TwclSerialClient(Classes::TComponent* AOwner);
	__fastcall virtual ~TwclSerialClient(void);
	int __fastcall Connect(void);
	int __fastcall Disconnect(void);
	int __fastcall GetReadBufferSize(/* out */ unsigned &Size);
	int __fastcall GetWriteBufferSize(/* out */ unsigned &Size);
	int __fastcall SetReadBufferSize(const unsigned Size);
	int __fastcall SetWriteBufferSize(const unsigned Size);
	int __fastcall Write(const void * Data, const unsigned Size, /* out */ unsigned &Written);
	int __fastcall GetFeatures(/* out */ TwclSerialFeatures &Features);
	int __fastcall GetConfig(/* out */ TwclSerialConfig &Config);
	int __fastcall SetConfig(const TwclSerialConfig &Config);
	int __fastcall GetTimeouts(/* out */ TwclSerialTimeouts &Timeouts);
	int __fastcall SetTimeouts(const TwclSerialTimeouts &Timeouts);
	int __fastcall ClearCommBreak(void);
	int __fastcall EscapeCommFunction(const TwclSerialEscapeFunction Func);
	int __fastcall FlushBuffers(void);
	int __fastcall GetModemStatus(/* out */ TwclModemStatuses &Status);
	int __fastcall PurgeComm(const TwclSerialPurgeFlags Flags);
	int __fastcall SetCommBreak(void);
	int __fastcall TransmitCommChar(const char Ch);
	__property Wclconnections::TwclCustomClientDataProcessor* Processor = {read=GetProcessor};
	__property Wclconnections::TwclClientState State = {read=GetState, nodefault};
	
__published:
	__property AnsiString DeviceName = {read=FDeviceName, write=SetDeviceName};
	__property unsigned WriteTimeout = {read=GetWriteTimeout, write=SetWriteTimeout, nodefault};
	__property Wclconnections::TwclClientConnectionConnectEvent OnConnect = {read=FOnConnect, write=FOnConnect};
	__property Wclconnections::TwclClientConnectionProcessorEvent OnCreateProcessor = {read=FOnCreateProcessor, write=FOnCreateProcessor};
	__property Wclconnections::TwclConnectionDataEvent OnData = {read=FOnData, write=FOnData};
	__property Wclconnections::TwclClientConnectionProcessorEvent OnDestroyProcessor = {read=FOnDestroyProcessor, write=FOnDestroyProcessor};
	__property Wclconnections::TwclClientConnectionDisconnectEvent OnDisconnect = {read=FOnDisconnect, write=FOnDisconnect};
	__property TwclSerialDeviceErrorEvent OnError = {read=FOnError, write=FOnError};
	__property TwclSerialDeviceEventsEvent OnEvents = {read=FOnEvents, write=FOnEvents};
	__property TwclSerialDeviceReadErrorEvent OnReadError = {read=FOnReadError, write=FOnReadError};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Wclserialclients */
using namespace Wclserialclients;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// wclSerialClients
