// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'wclSerialDevices.pas' rev: 6.00

#ifndef wclSerialDevicesHPP
#define wclSerialDevicesHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <wclWinAPI.hpp>	// Pascal unit
#include <wclErrors.hpp>	// Pascal unit
#include <wclMessaging.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Wclserialdevices
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 4)
struct TwclSerialDevice
{
	AnsiString FriendlyName;
	bool IsModem;
	AnsiString DeviceName;
} ;
#pragma pack(pop)

typedef DynamicArray<TwclSerialDevice >  TwclSerialDevices;

typedef void __fastcall (__closure *TwclSerialDeviceEvent)(System::TObject* Sender, const TwclSerialDevice &Device);

class DELPHICLASS TwclSerialMonitor;
class PASCALIMPLEMENTATION TwclSerialMonitor : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	_RTL_CRITICAL_SECTION FCS;
	Wclmessaging::TwclMessageReceiver* FReceiver;
	TwclSerialDeviceEvent FOnInserted;
	TwclSerialDeviceEvent FOnRemoved;
	int __fastcall InternalEnumDevices(const GUID &DevGuid, TwclSerialDevices &Devices);
	int __fastcall InternalEnumDevicesCfgMgr(/* out */ TwclSerialDevices &Devices);
	bool __fastcall GetMonitoring(void);
	
protected:
	virtual void __fastcall MessageReceived(const Wclmessaging::TwclMessage* Message);
	virtual void __fastcall DoInserted(const TwclSerialDevice &Device);
	virtual void __fastcall DoRemoved(const TwclSerialDevice &Device);
	
public:
	__fastcall virtual TwclSerialMonitor(Classes::TComponent* AOwner);
	__fastcall virtual ~TwclSerialMonitor(void);
	int __fastcall Start(void);
	int __fastcall Stop(void);
	int __fastcall EnumDevices(/* out */ TwclSerialDevices &Devices);
	__property bool Monitoring = {read=GetMonitoring, nodefault};
	
__published:
	__property TwclSerialDeviceEvent OnInserted = {read=FOnInserted, write=FOnInserted};
	__property TwclSerialDeviceEvent OnRemoved = {read=FOnRemoved, write=FOnRemoved};
};


#pragma pack(push, 4)
struct TwclUsbDevice
{
	AnsiString FriendlyName;
	AnsiString HardwareId;
	Word VendorId;
	Word ProductId;
	Word Revision;
	AnsiString Instance;
	AnsiString Manufacturer;
	GUID ClassGuid;
	bool Enabled;
} ;
#pragma pack(pop)

typedef DynamicArray<TwclUsbDevice >  TwclUsbDevices;

typedef void __fastcall (__closure *TwclUsbDeviceEvent)(System::TObject* Sender, const TwclUsbDevice &Device);

class DELPHICLASS TwclUsbMonitor;
class PASCALIMPLEMENTATION TwclUsbMonitor : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	_RTL_CRITICAL_SECTION FCS;
	Wclmessaging::TwclMessageReceiver* FReceiver;
	TwclUsbDeviceEvent FOnInserted;
	TwclUsbDeviceEvent FOnRemoved;
	int __fastcall GetDeviceStatus(const AnsiString Instance, /* out */ bool &Enabled);
	AnsiString __fastcall GetDevicePropertySetupApi(const AnsiString Instance, const unsigned Prop);
	AnsiString __fastcall GetDevicePropertyCfgMgr(const AnsiString Instance, const unsigned Prop);
	AnsiString __fastcall GetDeviceProperty(const AnsiString Instance, const unsigned Prop);
	Word __fastcall GetVendorId(const AnsiString HwId);
	Word __fastcall GetProductId(const AnsiString HwId);
	Word __fastcall GetRevision(const AnsiString HwId);
	void __fastcall AddDevice(const AnsiString DevId, TwclUsbDevices &Devices);
	int __fastcall EnumDevicesSetupApi(/* out */ TwclUsbDevices &Devices);
	int __fastcall EnumDevicesCfgMgr(/* out */ TwclUsbDevices &Devices);
	int __fastcall SwitchDevice(const AnsiString Instance, const bool Enable);
	bool __fastcall GetMonitoring(void);
	
protected:
	virtual void __fastcall MessageReceived(const Wclmessaging::TwclMessage* Message);
	virtual void __fastcall DoInserted(const TwclUsbDevice &Device);
	virtual void __fastcall DoRemoved(const TwclUsbDevice &Device);
	
public:
	__fastcall virtual TwclUsbMonitor(Classes::TComponent* AOwner);
	__fastcall virtual ~TwclUsbMonitor(void);
	int __fastcall Start(void);
	int __fastcall Stop(void);
	int __fastcall Disable(const AnsiString Instance);
	int __fastcall Enable(const AnsiString Instance);
	int __fastcall EnumDevices(/* out */ TwclUsbDevices &Devices);
	__property bool Monitoring = {read=GetMonitoring, nodefault};
	
__published:
	__property TwclUsbDeviceEvent OnInserted = {read=FOnInserted, write=FOnInserted};
	__property TwclUsbDeviceEvent OnRemoved = {read=FOnRemoved, write=FOnRemoved};
};


typedef DynamicArray<unsigned >  TwclComPortNumbers;

class DELPHICLASS TwclComDatabase;
class PASCALIMPLEMENTATION TwclComDatabase : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	unsigned FComDb;
	bool __fastcall GetOpened(void);
	
public:
	__fastcall virtual TwclComDatabase(Classes::TComponent* AOwner);
	__fastcall virtual ~TwclComDatabase(void);
	int __fastcall Close(void);
	int __fastcall Open(void);
	int __fastcall ClaimPort(/* out */ unsigned &Port);
	int __fastcall EnumUsedPorts(TwclComPortNumbers &Ports);
	int __fastcall ReleasePort(const unsigned Port);
	__property bool Opened = {read=GetOpened, nodefault};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE int __fastcall wclReadDeviceInformation(const AnsiString Instance, /* out */ TwclSerialDevice &Device);

}	/* namespace Wclserialdevices */
using namespace Wclserialdevices;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// wclSerialDevices
