// CodeGear C++Builder
// Copyright (c) 1995, 2011 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'wclSerialDevices.pas' rev: 23.00 (Win32)

#ifndef WclserialdevicesHPP
#define WclserialdevicesHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.Classes.hpp>	// Pascal unit
#include <Winapi.Windows.hpp>	// Pascal unit
#include <wclMessaging.hpp>	// Pascal unit
#include <wclErrors.hpp>	// Pascal unit
#include <wclWinAPI.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Wclserialdevices
{
//-- type declarations -------------------------------------------------------
struct DECLSPEC_DRECORD TwclSerialDevice
{
	
public:
	System::UnicodeString FriendlyName;
	bool IsModem;
	System::UnicodeString DeviceName;
};


typedef System::DynamicArray<TwclSerialDevice> TwclSerialDevices;

typedef void __fastcall (__closure *TwclSerialDeviceEvent)(System::TObject* Sender, const TwclSerialDevice &Device);

class DELPHICLASS TwclSerialMonitor;
class PASCALIMPLEMENTATION TwclSerialMonitor : public System::Classes::TComponent
{
	typedef System::Classes::TComponent inherited;
	
private:
	_RTL_CRITICAL_SECTION FCS;
	Wclmessaging::TwclMessageReceiver* FReceiver;
	TwclSerialDeviceEvent FOnInserted;
	TwclSerialDeviceEvent FOnRemoved;
	int __fastcall InternalEnumDevices(const GUID &DevGuid, TwclSerialDevices &Devices);
	int __fastcall InternalEnumDevicesCfgMgr(/* out */ TwclSerialDevices &Devices);
	bool __fastcall GetMonitoring(void);
	
protected:
	virtual void __fastcall MessageReceived(const Wclmessaging::TwclMessage* Message);
	virtual void __fastcall DoInserted(const TwclSerialDevice &Device);
	virtual void __fastcall DoRemoved(const TwclSerialDevice &Device);
	
public:
	__fastcall virtual TwclSerialMonitor(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TwclSerialMonitor(void);
	int __fastcall Start(void);
	int __fastcall Stop(void);
	int __fastcall EnumDevices(/* out */ TwclSerialDevices &Devices);
	__property bool Monitoring = {read=GetMonitoring, nodefault};
	
__published:
	__property TwclSerialDeviceEvent OnInserted = {read=FOnInserted, write=FOnInserted};
	__property TwclSerialDeviceEvent OnRemoved = {read=FOnRemoved, write=FOnRemoved};
};


struct DECLSPEC_DRECORD TwclUsbDevice
{
	
public:
	System::UnicodeString FriendlyName;
	System::UnicodeString HardwareId;
	System::Word VendorId;
	System::Word ProductId;
	System::Word Revision;
	System::UnicodeString Instance;
	System::UnicodeString Manufacturer;
	#pragma pack(push,1)
	GUID ClassGuid;
	#pragma pack(pop)
	bool Enabled;
};


typedef System::DynamicArray<TwclUsbDevice> TwclUsbDevices;

typedef void __fastcall (__closure *TwclUsbDeviceEvent)(System::TObject* Sender, const TwclUsbDevice &Device);

class DELPHICLASS TwclUsbMonitor;
class PASCALIMPLEMENTATION TwclUsbMonitor : public System::Classes::TComponent
{
	typedef System::Classes::TComponent inherited;
	
private:
	_RTL_CRITICAL_SECTION FCS;
	Wclmessaging::TwclMessageReceiver* FReceiver;
	TwclUsbDeviceEvent FOnInserted;
	TwclUsbDeviceEvent FOnRemoved;
	int __fastcall GetDeviceStatus(const System::UnicodeString Instance, /* out */ bool &Enabled);
	System::UnicodeString __fastcall GetDevicePropertySetupApi(const System::UnicodeString Instance, const unsigned Prop);
	System::UnicodeString __fastcall GetDevicePropertyCfgMgr(const System::UnicodeString Instance, const unsigned Prop);
	System::UnicodeString __fastcall GetDeviceProperty(const System::UnicodeString Instance, const unsigned Prop);
	System::Word __fastcall GetVendorId(const System::UnicodeString HwId);
	System::Word __fastcall GetProductId(const System::UnicodeString HwId);
	System::Word __fastcall GetRevision(const System::UnicodeString HwId);
	void __fastcall AddDevice(const System::UnicodeString DevId, TwclUsbDevices &Devices);
	int __fastcall EnumDevicesSetupApi(/* out */ TwclUsbDevices &Devices);
	int __fastcall EnumDevicesCfgMgr(/* out */ TwclUsbDevices &Devices);
	int __fastcall SwitchDevice(const System::UnicodeString Instance, const bool Enable);
	bool __fastcall GetMonitoring(void);
	
protected:
	virtual void __fastcall MessageReceived(const Wclmessaging::TwclMessage* Message);
	virtual void __fastcall DoInserted(const TwclUsbDevice &Device);
	virtual void __fastcall DoRemoved(const TwclUsbDevice &Device);
	
public:
	__fastcall virtual TwclUsbMonitor(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TwclUsbMonitor(void);
	int __fastcall Start(void);
	int __fastcall Stop(void);
	int __fastcall Disable(const System::UnicodeString Instance);
	int __fastcall Enable(const System::UnicodeString Instance);
	int __fastcall EnumDevices(/* out */ TwclUsbDevices &Devices);
	__property bool Monitoring = {read=GetMonitoring, nodefault};
	
__published:
	__property TwclUsbDeviceEvent OnInserted = {read=FOnInserted, write=FOnInserted};
	__property TwclUsbDeviceEvent OnRemoved = {read=FOnRemoved, write=FOnRemoved};
};


typedef System::DynamicArray<unsigned> TwclComPortNumbers;

class DELPHICLASS TwclComDatabase;
#pragma pack(push,4)
class PASCALIMPLEMENTATION TwclComDatabase : public System::Classes::TComponent
{
	typedef System::Classes::TComponent inherited;
	
private:
	unsigned FComDb;
	bool __fastcall GetOpened(void);
	
public:
	__fastcall virtual TwclComDatabase(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TwclComDatabase(void);
	int __fastcall Close(void);
	int __fastcall Open(void);
	int __fastcall ClaimPort(/* out */ unsigned &Port);
	int __fastcall EnumUsedPorts(TwclComPortNumbers &Ports);
	int __fastcall ReleasePort(const unsigned Port);
	__property bool Opened = {read=GetOpened, nodefault};
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE int __fastcall wclReadDeviceInformation(const System::UnicodeString Instance, /* out */ TwclSerialDevice &Device);

}	/* namespace Wclserialdevices */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_WCLSERIALDEVICES)
using namespace Wclserialdevices;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// WclserialdevicesHPP
