////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//   Wireless Communication Library 7                                         //
//                                                                            //
//   Copyright (C) 2006-2024 Mike Petrichenko                                 //
//                           Soft Service Company                             //
//                           All Rights Reserved                              //
//                                                                            //
//   http://www.btframework.com                                               //
//                                                                            //
//   support@btframework.com                                                  //
//   shop@btframework.com                                                     //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

{$IFNDEF FPC}
  {$DEFINITIONINFO ON}
  {$REFERENCEINFO ON}
{$ENDIF}

{$IFNDEF _WCL_DEBUG_}
  {$ASSERTIONS OFF}
  {$DEBUGINFO OFF}
  {$IFNDEF FPC}
    {$LOCALSYMBOLS OFF}
  {$ENDIF}
  {$IOCHECKS OFF}
  {$OVERFLOWCHECKS OFF}
  {$OPTIMIZATION OFF}
{$ELSE}
  {$ASSERTIONS ON}
  {$DEBUGINFO ON}
  {$IFNDEF FPC}
    {$LOCALSYMBOLS ON}
  {$ENDIF}
  {$IOCHECKS ON}
  {.$OVERFLOWCHECKS ON}
  {$OVERFLOWCHECKS OFF}
  {$OPTIMIZATION ON}
{$ENDIF}

{$STACKFRAMES OFF}
{$IFNDEF FPC}
  {$SAFEDIVIDE OFF}
{$ENDIF}
{$IFDEF VER130}
  {$ALIGN ON}
{$ELSE}
  {$ALIGN 8}
{$ENDIF}
{$RANGECHECKS OFF}
{$VARSTRINGCHECKS OFF}
{$BOOLEVAL OFF}
{$EXTENDEDSYNTAX ON}
{$TYPEDADDRESS OFF}
{$OPENSTRINGS OFF}
{$LONGSTRINGS ON}
{$WRITEABLECONST OFF}
{$MINENUMSIZE 4}

{$IFDEF FPC}
  {$DEFINE VER150}
  {$UNDEF BCB}

  {$MODE Delphi}
  {$COPERATORS OFF}
  {$GOTO ON}
  {$INLINE OFF}
  {$MACRO OFF}

  {$warnings off}
  {$hints off}
  {$notes off}
{$ENDIF}

{$IFDEF BCB}
  {$ObjExportAll On}
{$ENDIF}

{$IFDEF VER140}
  {$DEFINE D6}
  {$IFDEF BCB}
    {$DEFINE C6}
  {$ENDIF}
{$ENDIF}

{$IFDEF VER150}
  {$DEFINE D6}
  {$DEFINE D7}
{$ENDIF}

{$IFDEF VER170}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
{$ENDIF}

{$IFDEF VER180}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$IFDEF VER185}
    {$DEFINE D2007}
  {$ENDIF}
{$ENDIF}

{$IFDEF VER200}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
{$ENDIF}

{$IFDEF VER210}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
{$ENDIF}

{$IFDEF VER220}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
{$ENDIF}

{$IFDEF VER230}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
{$ENDIF}

{$IFDEF VER240}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
{$ENDIF}

{$IFDEF VER250}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
  {$DEFINE DXE4}
{$ENDIF}

{$IFDEF VER260}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
  {$DEFINE DXE4}
  {$DEFINE DXE5}
{$ENDIF}

{$IFDEF VER270}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
  {$DEFINE DXE4}
  {$DEFINE DXE5}
  {$DEFINE DXE6}
{$ENDIF}

{$IFDEF VER280}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
  {$DEFINE DXE4}
  {$DEFINE DXE5}
  {$DEFINE DXE6}
  {$DEFINE DXE7}
{$ENDIF}

{$IFDEF VER290}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
  {$DEFINE DXE4}
  {$DEFINE DXE5}
  {$DEFINE DXE6}
  {$DEFINE DXE7}
  {$DEFINE DXE8}
{$ENDIF}

{$IFDEF VER300}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
  {$DEFINE DXE4}
  {$DEFINE DXE5}
  {$DEFINE DXE6}
  {$DEFINE DXE7}
  {$DEFINE DXE8}
  {$DEFINE D10}
{$ENDIF}

{$IFDEF VER310}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
  {$DEFINE DXE4}
  {$DEFINE DXE5}
  {$DEFINE DXE6}
  {$DEFINE DXE7}
  {$DEFINE DXE8}
  {$DEFINE D10}
  {$DEFINE D101}
{$ENDIF}

{$IFDEF VER320}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
  {$DEFINE DXE4}
  {$DEFINE DXE5}
  {$DEFINE DXE6}
  {$DEFINE DXE7}
  {$DEFINE DXE8}
  {$DEFINE D10}
  {$DEFINE D101}
  {$DEFINE D102}
{$ENDIF}

{$IFDEF VER330}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
  {$DEFINE DXE4}
  {$DEFINE DXE5}
  {$DEFINE DXE6}
  {$DEFINE DXE7}
  {$DEFINE DXE8}
  {$DEFINE D10}
  {$DEFINE D101}
  {$DEFINE D102}
  {$DEFINE D103}
{$ENDIF}

{$IFDEF VER340}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
  {$DEFINE DXE4}
  {$DEFINE DXE5}
  {$DEFINE DXE6}
  {$DEFINE DXE7}
  {$DEFINE DXE8}
  {$DEFINE D10}
  {$DEFINE D101}
  {$DEFINE D102}
  {$DEFINE D103}
  {$DEFINE D104}
{$ENDIF}

{$IFDEF VER350}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
  {$DEFINE DXE4}
  {$DEFINE DXE5}
  {$DEFINE DXE6}
  {$DEFINE DXE7}
  {$DEFINE DXE8}
  {$DEFINE D10}
  {$DEFINE D101}
  {$DEFINE D102}
  {$DEFINE D103}
  {$DEFINE D104}
  {$DEFINE D11}
{$ENDIF}

{$IFDEF VER360}
  {$DEFINE D6}
  {$DEFINE D7}
  {$DEFINE D2005}
  {$DEFINE D2006}
  {$DEFINE D2007}
  {$DEFINE D2009}
  {$DEFINE D2010}
  {$DEFINE DXE}
  {$DEFINE DXE2}
  {$DEFINE DXE3}
  {$DEFINE DXE4}
  {$DEFINE DXE5}
  {$DEFINE DXE6}
  {$DEFINE DXE7}
  {$DEFINE DXE8}
  {$DEFINE D10}
  {$DEFINE D101}
  {$DEFINE D102}
  {$DEFINE D103}
  {$DEFINE D104}
  {$DEFINE D11}
  {$DEFINE D12}
{$ENDIF}

{$IFDEF D2010}
  {$RTTI EXPLICIT METHODS([]) PROPERTIES([]) FIELDS([])}
{$ENDIF}

{$IFNDEF D6}
  {$MESSAGE FATAL 'Unsupported Delphi or CBuilder version'}
{$ENDIF}
